# Class: ComponentTemplate

## ComponentTemplate()

#### new ComponentTemplate()

NB: Attributes not available here - use connectedCallback to reference

Source:
  - alpha/component-template.js, line 108

### Members

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

### Methods

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126

## ComponentTemplate()

#### new ComponentTemplate()

NB: Attributes not available here - use connectedCallback to reference

Source:
  - alpha/component-template.js, line 108

### Members

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

### Methods

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126

## ComponentTemplate()

#### new ComponentTemplate()

NB: Attributes not available here - use connectedCallback to reference

Source:
  - alpha/component-template.js, line 108

### Members

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### componentVersion

Component version

Source:
  - alpha/component-template.js, line 94

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

#### (static) observedAttributes

Makes HTML attribute change watched

Source:
  - alpha/component-template.js, line 99

### Methods

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### attributeChangedCallback(attrib, oldVal, newVal)

Runs when an observed attribute changes - Note: values are always strings NOTE: On initial startup, this is called for each watched attrib set in HTML. and BEFORE connectedCallback is called.

##### Parameters:

Name | Type | Description
--- | --- | ---
`attrib` | string | Name of watched attribute that has changed
`oldVal` | string | The previous attribute value
`newVal` | string | The new attribute value

Source:
  - alpha/component-template.js, line 137

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### connectedCallback()

Runs when an instance is added to the DOM Runs AFTER the initial attributeChangedCallback's

Source:
  - alpha/component-template.js, line 119

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126

#### disconnectedCallback()

Runs when an instance is removed from the DOM

Source:
  - alpha/component-template.js, line 126